##// END OF EJS Templates
bugfixes...
Unknown -
r337:0f6491a67cae
parent child
Show More
@@ -1,796 +1,796
1 #!/bin/sh
1 #!/bin/sh
2
2
3 ########################################################################
3 ########################################################################
4 # rpi23-gen-image.sh 2015-2017
4 # rpi23-gen-image.sh 2015-2017
5 #
5 #
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 #
7 #
8 # This program is free software; you can redistribute it and/or
8 # This program is free software; you can redistribute it and/or
9 # modify it under the terms of the GNU General Public License
9 # modify it under the terms of the GNU General Public License
10 # as published by the Free Software Foundation; either version 2
10 # as published by the Free Software Foundation; either version 2
11 # of the License, or (at your option) any later version.
11 # of the License, or (at your option) any later version.
12 #
12 #
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 #
14 #
15 # Big thanks for patches and enhancements by 20+ github contributors!
15 # Big thanks for patches and enhancements by 20+ github contributors!
16 ########################################################################
16 ########################################################################
17
17
18 # Are we running as root?
18 # Are we running as root?
19 if [ "$(id -u)" -ne "0" ] ; then
19 if [ "$(id -u)" -ne "0" ] ; then
20 echo "error: this script must be executed with root privileges!"
20 echo "error: this script must be executed with root privileges!"
21 exit 1
21 exit 1
22 fi
22 fi
23
23
24 # Check if ./functions.sh script exists
24 # Check if ./functions.sh script exists
25 if [ ! -r "./functions.sh" ] ; then
25 if [ ! -r "./functions.sh" ] ; then
26 echo "error: './functions.sh' required script not found!"
26 echo "error: './functions.sh' required script not found!"
27 exit 1
27 exit 1
28 fi
28 fi
29
29
30 # Load utility functions
30 # Load utility functions
31 . ./functions.sh
31 . ./functions.sh
32
32
33 # Load parameters from configuration template file
33 # Load parameters from configuration template file
34 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 if [ -n "$CONFIG_TEMPLATE" ] ; then
35 use_template
35 use_template
36 fi
36 fi
37
37
38 # Introduce settings
38 # Introduce settings
39 set -e
39 set -e
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 set -x
41 set -x
42
42
43 # Raspberry Pi model configuration
43 # Raspberry Pi model configuration
44 RPI_MODEL=${RPI_MODEL:=2}
44 RPI_MODEL=${RPI_MODEL:=2}
45
45
46 #bcm2708-rpi-0-w.dtb (Used for Pi 0 and PI 0W)
46 #bcm2708-rpi-0-w.dtb (Used for Pi 0 and PI 0W)
47 RPI0_DTB_FILE=${RPI0_DTB_FILE:=bcm2708-rpi-0-w.dtb}
47 RPI0_DTB_FILE=${RPI0_DTB_FILE:=bcm2708-rpi-0-w.dtb}
48 RPI0_UBOOT_CONFIG=${RPI0_UBOOT_CONFIG:=rpi_defconfig}
48 RPI0_UBOOT_CONFIG=${RPI0_UBOOT_CONFIG:=rpi_defconfig}
49
49
50 #bcm2708-rpi-b.dtb (Used for Pi 1 model A and B)
50 #bcm2708-rpi-b.dtb (Used for Pi 1 model A and B)
51 RPI1_DTB_FILE=${RPI1_DTB_FILE:=bcm2708-rpi-b.dtb}
51 RPI1_DTB_FILE=${RPI1_DTB_FILE:=bcm2708-rpi-b.dtb}
52 RPI1_UBOOT_CONFIG=${RPI1_UBOOT_CONFIG:=rpi_defconfig}
52 RPI1_UBOOT_CONFIG=${RPI1_UBOOT_CONFIG:=rpi_defconfig}
53
53
54 #bcm2708-rpi-b-plus.dtb (Used for Pi 1 model B+ and A+)
54 #bcm2708-rpi-b-plus.dtb (Used for Pi 1 model B+ and A+)
55 RPI1P_DTB_FILE=${RPI1P_DTB_FILE:=bcm2708-rpi-b-plus.dtb}
55 RPI1P_DTB_FILE=${RPI1P_DTB_FILE:=bcm2708-rpi-b-plus.dtb}
56 RPI1P_UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG:=rpi_defconfig}
56 RPI1P_UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG:=rpi_defconfig}
57
57
58 #bcm2709-rpi-2-b.dtb (Used for Pi 2 model B)
58 #bcm2709-rpi-2-b.dtb (Used for Pi 2 model B)
59 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
59 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
60 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
60 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
61
61
62 #bcm2710-rpi-3-b.dtb (Used for Pi 3 model B)
62 #bcm2710-rpi-3-b.dtb (Used for Pi 3 model B)
63 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
63 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
64 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
64 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
65
65
66 #bcm2710-rpi-3-b-plus.dtb (Used for Pi 3 model B+)
66 #bcm2710-rpi-3-b-plus.dtb (Used for Pi 3 model B+)
67 RPI3P_DTB_FILE=${RPI3P_DTB_FILE:=bcm2710-rpi-3-b-plus.dtb}
67 RPI3P_DTB_FILE=${RPI3P_DTB_FILE:=bcm2710-rpi-3-b-plus.dtb}
68 RPI3P_UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG:=rpi_3_32b_defconfig}
68 RPI3P_UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG:=rpi_3_32b_defconfig}
69
69
70 # Debian release
70 # Debian release
71 RELEASE=${RELEASE:=jessie}
71 RELEASE=${RELEASE:=jessie}
72 KERNEL_ARCH=${KERNEL_ARCH:=arm}
72 KERNEL_ARCH=${KERNEL_ARCH:=arm}
73 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
73 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
74 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
74 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
75 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
75 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
76 if [ "$KERNEL_ARCH" = "arm64" ] ; then
76 if [ "$KERNEL_ARCH" = "arm64" ] ; then
77 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
77 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
78 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
78 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
79 fi
79 fi
80
80
81 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
81 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
82 #RASPBERRY PI 1, PI ZERO, PI ZERO W, AND COMPUTE MODULE DEFAULT Kernel BUILD CONFIGURATION
82 #RASPBERRY PI 1, PI ZERO, PI ZERO W, AND COMPUTE MODULE DEFAULT Kernel BUILD CONFIGURATION
83 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
83 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
84 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
84 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
85 else
85 else
86 #RASPBERRY PI 2, PI 3, PI 3+, AND COMPUTE MODULE 3 DEFAULT Kernel BUILD CONFIGURATION
86 #RASPBERRY PI 2, PI 3, PI 3+, AND COMPUTE MODULE 3 DEFAULT Kernel BUILD CONFIGURATION
87 #https://www.raspberrypi.org/documentation/linux/kernel/building.md
87 #https://www.raspberrypi.org/documentation/linux/kernel/building.md
88 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
88 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
89 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
89 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
90 fi
90 fi
91
91
92 if [ "$RELEASE_ARCH" = "arm64" ] ; then
92 if [ "$RELEASE_ARCH" = "arm64" ] ; then
93 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
93 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
94 else
94 else
95 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
95 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
96 fi
96 fi
97 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
97 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
98
98
99 # URLs
99 # URLs
100 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
100 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
101 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
101 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
102 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
102 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
103 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
103 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
104 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
104 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
105 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
105 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
106 VIDEOCORE_URL=${VIDEOCORE_URL=https://github.com/raspberrypi/userland}
106 VIDEOCORE_URL=${VIDEOCORE_URL=https://github.com/raspberrypi/userland}
107
107
108 # Build directories
108 # Build directories
109 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
109 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
110 BUILDDIR="${BASEDIR}/build"
110 BUILDDIR="${BASEDIR}/build"
111
111
112 # Prepare date string for default image file name
112 # Prepare date string for default image file name
113 DATE="$(date +%Y-%m-%d)"
113 DATE="$(date +%Y-%m-%d)"
114 if [ -z "$KERNEL_BRANCH" ] ; then
114 if [ -z "$KERNEL_BRANCH" ] ; then
115 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
115 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
116 else
116 else
117 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
117 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
118 fi
118 fi
119
119
120 # Chroot directories
120 # Chroot directories
121 R="${BUILDDIR}/chroot"
121 R="${BUILDDIR}/chroot"
122 ETC_DIR="${R}/etc"
122 ETC_DIR="${R}/etc"
123 LIB_DIR="${R}/lib"
123 LIB_DIR="${R}/lib"
124 BOOT_DIR="${R}/boot/firmware"
124 BOOT_DIR="${R}/boot/firmware"
125 KERNEL_DIR="${R}/usr/src/linux"
125 KERNEL_DIR="${R}/usr/src/linux"
126 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
126 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
127
127
128 # Firmware directory: Blank if download from github
128 # Firmware directory: Blank if download from github
129 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
129 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
130
130
131 # General settings
131 # General settings
132 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
132 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
133 PASSWORD=${PASSWORD:=raspberry}
133 PASSWORD=${PASSWORD:=raspberry}
134 USER_PASSWORD=${USER_PASSWORD:=raspberry}
134 USER_PASSWORD=${USER_PASSWORD:=raspberry}
135 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
135 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
136 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
136 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
137 EXPANDROOT=${EXPANDROOT:=true}
137 EXPANDROOT=${EXPANDROOT:=true}
138
138
139 # Keyboard settings
139 # Keyboard settings
140 XKB_MODEL=${XKB_MODEL:=""}
140 XKB_MODEL=${XKB_MODEL:=""}
141 XKB_LAYOUT=${XKB_LAYOUT:=""}
141 XKB_LAYOUT=${XKB_LAYOUT:=""}
142 XKB_VARIANT=${XKB_VARIANT:=""}
142 XKB_VARIANT=${XKB_VARIANT:=""}
143 XKB_OPTIONS=${XKB_OPTIONS:=""}
143 XKB_OPTIONS=${XKB_OPTIONS:=""}
144
144
145 # Network settings (DHCP)
145 # Network settings (DHCP)
146 ENABLE_DHCP=${ENABLE_DHCP:=true}
146 ENABLE_DHCP=${ENABLE_DHCP:=true}
147
147
148 # Network settings (static)
148 # Network settings (static)
149 NET_ADDRESS=${NET_ADDRESS:=""}
149 NET_ADDRESS=${NET_ADDRESS:=""}
150 NET_GATEWAY=${NET_GATEWAY:=""}
150 NET_GATEWAY=${NET_GATEWAY:=""}
151 NET_DNS_1=${NET_DNS_1:=""}
151 NET_DNS_1=${NET_DNS_1:=""}
152 NET_DNS_2=${NET_DNS_2:=""}
152 NET_DNS_2=${NET_DNS_2:=""}
153 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
153 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
154 NET_NTP_1=${NET_NTP_1:=""}
154 NET_NTP_1=${NET_NTP_1:=""}
155 NET_NTP_2=${NET_NTP_2:=""}
155 NET_NTP_2=${NET_NTP_2:=""}
156
156
157 # APT settings
157 # APT settings
158 APT_PROXY=${APT_PROXY:=""}
158 APT_PROXY=${APT_PROXY:=""}
159 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
159 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
160
160
161 # Feature settings
161 # Feature settings
162 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
162 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
163 ENABLE_I2C=${ENABLE_I2C:=false}
163 ENABLE_I2C=${ENABLE_I2C:=false}
164 ENABLE_SPI=${ENABLE_SPI:=false}
164 ENABLE_SPI=${ENABLE_SPI:=false}
165 ENABLE_IPV6=${ENABLE_IPV6:=true}
165 ENABLE_IPV6=${ENABLE_IPV6:=true}
166 ENABLE_SSHD=${ENABLE_SSHD:=true}
166 ENABLE_SSHD=${ENABLE_SSHD:=true}
167 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
167 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
168 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
168 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
169 ENABLE_SOUND=${ENABLE_SOUND:=true}
169 ENABLE_SOUND=${ENABLE_SOUND:=true}
170 ENABLE_DBUS=${ENABLE_DBUS:=true}
170 ENABLE_DBUS=${ENABLE_DBUS:=true}
171 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
171 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
172 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
172 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
173 ENABLE_XORG=${ENABLE_XORG:=false}
173 ENABLE_XORG=${ENABLE_XORG:=false}
174 ENABLE_WM=${ENABLE_WM:=""}
174 ENABLE_WM=${ENABLE_WM:=""}
175 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
175 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
176 ENABLE_USER=${ENABLE_USER:=true}
176 ENABLE_USER=${ENABLE_USER:=true}
177 USER_NAME=${USER_NAME:="pi"}
177 USER_NAME=${USER_NAME:="pi"}
178 ENABLE_ROOT=${ENABLE_ROOT:=false}
178 ENABLE_ROOT=${ENABLE_ROOT:=false}
179 ENABLE_QEMU=${ENABLE_QEMU:=false}
179 ENABLE_QEMU=${ENABLE_QEMU:=false}
180 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
180 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
181
181
182 # SSH settings
182 # SSH settings
183 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
183 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
184 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
184 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
185 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
185 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
186 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
186 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
187 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
187 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
188
188
189 # Advanced settings
189 # Advanced settings
190 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
190 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
191 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
191 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
192 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
192 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
193 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
193 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
194 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
194 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
195 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=true}
195 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=true}
196 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
196 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
197 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
197 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
198 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
198 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
199 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
199 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
200 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
200 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
201 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
201 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
202 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
202 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
203 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
203 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
204
204
205 # Kernel compilation settings
205 # Kernel compilation settings
206 BUILD_KERNEL=${BUILD_KERNEL:=false}
206 BUILD_KERNEL=${BUILD_KERNEL:=false}
207 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
207 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
208 KERNEL_THREADS=${KERNEL_THREADS:=1}
208 KERNEL_THREADS=${KERNEL_THREADS:=1}
209 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
209 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
210 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
210 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
211 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
211 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
212 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
212 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
213 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
213 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
214
214
215 if [ "$KERNEL_ARCH" = "arm64" ] ; then
215 if [ "$KERNEL_ARCH" = "arm64" ] ; then
216 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
216 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
217 else
217 else
218 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
218 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
219 fi
219 fi
220
220
221 # Kernel compilation from source directory settings
221 # Kernel compilation from source directory settings
222 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
222 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
223 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
223 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
224 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
224 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
225 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
225 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
226
226
227 # Reduce disk usage settings
227 # Reduce disk usage settings
228 REDUCE_APT=${REDUCE_APT:=true}
228 REDUCE_APT=${REDUCE_APT:=true}
229 REDUCE_DOC=${REDUCE_DOC:=true}
229 REDUCE_DOC=${REDUCE_DOC:=true}
230 REDUCE_MAN=${REDUCE_MAN:=true}
230 REDUCE_MAN=${REDUCE_MAN:=true}
231 REDUCE_VIM=${REDUCE_VIM:=false}
231 REDUCE_VIM=${REDUCE_VIM:=false}
232 REDUCE_BASH=${REDUCE_BASH:=false}
232 REDUCE_BASH=${REDUCE_BASH:=false}
233 REDUCE_HWDB=${REDUCE_HWDB:=true}
233 REDUCE_HWDB=${REDUCE_HWDB:=true}
234 REDUCE_SSHD=${REDUCE_SSHD:=true}
234 REDUCE_SSHD=${REDUCE_SSHD:=true}
235 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
235 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
236
236
237 # Encrypted filesystem settings
237 # Encrypted filesystem settings
238 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
238 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
239 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
239 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
240 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
240 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
241 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
241 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
242 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
242 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
243
243
244 # Chroot scripts directory
244 # Chroot scripts directory
245 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
245 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
246
246
247 # Packages required in the chroot build environment
247 # Packages required in the chroot build environment
248 APT_INCLUDES=${APT_INCLUDES:=""}
248 APT_INCLUDES=${APT_INCLUDES:=""}
249 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
249 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
250
250
251 #Packages to exclude from chroot build environment
251 #Packages to exclude from chroot build environment
252 APT_EXCLUDES=${APT_EXCLUDES:=""}
252 APT_EXCLUDES=${APT_EXCLUDES:=""}
253
253
254 # Packages required for bootstrapping
254 # Packages required for bootstrapping
255 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
255 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
256 MISSING_PACKAGES=""
256 MISSING_PACKAGES=""
257
257
258 # Packages installed for c/c++ build environment in chroot (keep empty)
258 # Packages installed for c/c++ build environment in chroot (keep empty)
259 COMPILER_PACKAGES=""
259 COMPILER_PACKAGES=""
260
260
261 set +x
261 set +x
262
262
263 #If init and systemd-sysv are wanted e.g. halt/reboot/shutdown scripts
263 #If init and systemd-sysv are wanted e.g. halt/reboot/shutdown scripts
264 if [ "$ENABLE_SYSVINIT" = false ] ; then
264 if [ "$ENABLE_SYSVINIT" = false ] ; then
265 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
265 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
266 fi
266 fi
267
267
268 # Set Raspberry Pi model specific configuration
268 # Set Raspberry Pi model specific configuration
269 if [ "$RPI_MODEL" = 0 ] ; then
269 if [ "$RPI_MODEL" = 0 ] ; then
270 DTB_FILE=${RPI0_DTB_FILE}
270 DTB_FILE=${RPI0_DTB_FILE}
271 UBOOT_CONFIG=${RPI0_UBOOT_CONFIG}
271 UBOOT_CONFIG=${RPI0_UBOOT_CONFIG}
272 elif [ "$RPI_MODEL" = 1 ] ; then
272 elif [ "$RPI_MODEL" = 1 ] ; then
273 DTB_FILE=${RPI1_DTB_FILE}
273 DTB_FILE=${RPI1_DTB_FILE}
274 UBOOT_CONFIG=${RPI1_UBOOT_CONFIG}
274 UBOOT_CONFIG=${RPI1_UBOOT_CONFIG}
275 elif [ "$RPI_MODEL" = 1P ] ; then
275 elif [ "$RPI_MODEL" = 1P ] ; then
276 DTB_FILE=${RPI1P_DTB_FILE}
276 DTB_FILE=${RPI1P_DTB_FILE}
277 UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG}
277 UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG}
278 elif [ "$RPI_MODEL" = 2 ] ; then
278 elif [ "$RPI_MODEL" = 2 ] ; then
279 DTB_FILE=${RPI2_DTB_FILE}
279 DTB_FILE=${RPI2_DTB_FILE}
280 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
280 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
281 elif [ "$RPI_MODEL" = 3 ] ; then
281 elif [ "$RPI_MODEL" = 3 ] ; then
282 DTB_FILE=${RPI3_DTB_FILE}
282 DTB_FILE=${RPI3_DTB_FILE}
283 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
283 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
284 elif [ "$RPI_MODEL" = 3P ] ; then
284 elif [ "$RPI_MODEL" = 3P ] ; then
285 DTB_FILE=${RPI3P_DTB_FILE}
285 DTB_FILE=${RPI3P_DTB_FILE}
286 UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG}
286 UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG}
287 else
287 else
288 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
288 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
289 exit 1
289 exit 1
290 fi
290 fi
291
291
292 # Check if the internal wireless interface is supported by the RPi model
292 # Check if the internal wireless interface is supported by the RPi model
293 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]); then
293 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]); then
294
294
295 echo "error: The selected Raspberry Pi model has no internal wireless interface"
295 echo "error: The selected Raspberry Pi model has no internal wireless interface"
296 exit 1
296 exit 1
297 fi
297 fi
298
298
299 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
299 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
300 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
300 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
301 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
301 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
302 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
302 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
303 exit 1
303 exit 1
304 fi
304 fi
305 fi
305 fi
306
306
307 # Build RPi2/3 Linux kernel if required by Debian release
307 # Build RPi2/3 Linux kernel if required by Debian release
308 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
308 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
309 BUILD_KERNEL=true
309 BUILD_KERNEL=true
310 fi
310 fi
311
311
312 # Add packages required for kernel cross compilation
312 # Add packages required for kernel cross compilation
313 if [ "$BUILD_KERNEL" = true ] ; then
313 if [ "$BUILD_KERNEL" = true ] ; then
314 if [ "$KERNEL_ARCH" = "arm" ] ; then
314 if [ "$KERNEL_ARCH" = "arm" ] ; then
315 if [ "$RELEASE_ARCH" = "armel" ]; then
315 if [ "$RELEASE_ARCH" = "armel" ]; then
316 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
316 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
317 fi
317 fi
318 if [ "$RELEASE_ARCH" = "armhf" ]; then
318 if [ "$RELEASE_ARCH" = "armhf" ]; then
319 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
319 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
320 fi
320 fi
321 fi
321 fi
322 if [ "$RELEASE_ARCH" = "arm64" ]; then
322 if [ "$RELEASE_ARCH" = "arm64" ]; then
323 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
323 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
324 fi
324 fi
325 fi
325 fi
326
326
327 if [ "$ENABLE_VIDEOCORE" = true ] ; then
327 if [ "$ENABLE_VIDEOCORE" = true ] ; then
328 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
328 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
329 fi
329 fi
330
330
331 # Add libncurses5 to enable kernel menuconfig
331 # Add libncurses5 to enable kernel menuconfig
332 if [ "$KERNEL_MENUCONFIG" = true ] ; then
332 if [ "$KERNEL_MENUCONFIG" = true ] ; then
333 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
333 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
334 fi
334 fi
335
335
336 # Add ccache compiler cache for (faster) kernel cross (re)compilation
336 # Add ccache compiler cache for (faster) kernel cross (re)compilation
337 if [ "$KERNEL_CCACHE" = true ] ; then
337 if [ "$KERNEL_CCACHE" = true ] ; then
338 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
338 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
339 fi
339 fi
340
340
341 # Add cryptsetup package to enable filesystem encryption
341 # Add cryptsetup package to enable filesystem encryption
342 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
342 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
343 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
343 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
344 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
344 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
345
345
346 if [ -z "$CRYPTFS_PASSWORD" ] ; then
346 if [ -z "$CRYPTFS_PASSWORD" ] ; then
347 echo "error: no password defined (CRYPTFS_PASSWORD)!"
347 echo "error: no password defined (CRYPTFS_PASSWORD)!"
348 exit 1
348 exit 1
349 fi
349 fi
350 ENABLE_INITRAMFS=true
350 ENABLE_INITRAMFS=true
351 fi
351 fi
352
352
353 # Add initramfs generation tools
353 # Add initramfs generation tools
354 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
354 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
355 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
355 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
356 fi
356 fi
357
357
358 # Add device-tree-compiler required for building the U-Boot bootloader
358 # Add device-tree-compiler required for building the U-Boot bootloader
359 if [ "$ENABLE_UBOOT" = true ] ; then
359 if [ "$ENABLE_UBOOT" = true ] ; then
360 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
360 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
361 fi
361 fi
362
362
363 # Check if root SSH (v2) public key file exists
363 # Check if root SSH (v2) public key file exists
364 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
364 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
365 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
365 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
366 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
366 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
367 exit 1
367 exit 1
368 fi
368 fi
369 fi
369 fi
370
370
371 # Check if $USER_NAME SSH (v2) public key file exists
371 # Check if $USER_NAME SSH (v2) public key file exists
372 if [ -n "$SSH_USER_PUB_KEY" ] ; then
372 if [ -n "$SSH_USER_PUB_KEY" ] ; then
373 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
373 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
374 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
374 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
375 exit 1
375 exit 1
376 fi
376 fi
377 fi
377 fi
378
378
379 # Check if all required packages are installed on the build system
379 # Check if all required packages are installed on the build system
380 for package in $REQUIRED_PACKAGES ; do
380 for package in $REQUIRED_PACKAGES ; do
381 if [ "$(dpkg-query -W -f='${Status}' $package)" != "install ok installed" ] ; then
381 if [ "$(dpkg-query -W -f='${Status}' $package)" != "install ok installed" ] ; then
382 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
382 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
383 fi
383 fi
384 done
384 done
385
385
386 # If there are missing packages ask confirmation for install, or exit
386 # If there are missing packages ask confirmation for install, or exit
387 if [ -n "$MISSING_PACKAGES" ] ; then
387 if [ -n "$MISSING_PACKAGES" ] ; then
388 echo "the following packages needed by this script are not installed:"
388 echo "the following packages needed by this script are not installed:"
389 echo "$MISSING_PACKAGES"
389 echo "$MISSING_PACKAGES"
390
390
391 printf "\n\ndo you want to install the missing packages right now? [y/n] "
391 printf "\ndo you want to install the missing packages right now? [y/n] "
392 read -r confirm
392 read -r confirm
393 [ "$confirm" != "y" ] && exit 1
393 [ "$confirm" != "y" ] && exit 1
394
394
395 # Make sure all missing required packages are installed
395 # Make sure all missing required packages are installed
396 apt-get -qq -y install "${MISSING_PACKAGES}"
396 apt-get -qq -y install "${MISSING_PACKAGES}"
397 fi
397 fi
398
398
399 # Check if ./bootstrap.d directory exists
399 # Check if ./bootstrap.d directory exists
400 if [ ! -d "./bootstrap.d/" ] ; then
400 if [ ! -d "./bootstrap.d/" ] ; then
401 echo "error: './bootstrap.d' required directory not found!"
401 echo "error: './bootstrap.d' required directory not found!"
402 exit 1
402 exit 1
403 fi
403 fi
404
404
405 # Check if ./files directory exists
405 # Check if ./files directory exists
406 if [ ! -d "./files/" ] ; then
406 if [ ! -d "./files/" ] ; then
407 echo "error: './files' required directory not found!"
407 echo "error: './files' required directory not found!"
408 exit 1
408 exit 1
409 fi
409 fi
410
410
411 # Check if specified KERNELSRC_DIR directory exists
411 # Check if specified KERNELSRC_DIR directory exists
412 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
412 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
413 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
413 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
414 exit 1
414 exit 1
415 fi
415 fi
416
416
417 # Check if specified UBOOTSRC_DIR directory exists
417 # Check if specified UBOOTSRC_DIR directory exists
418 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
418 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
419 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
419 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
420 exit 1
420 exit 1
421 fi
421 fi
422
422
423 # Check if specified VIDEOCORESRC_DIR directory exists
423 # Check if specified VIDEOCORESRC_DIR directory exists
424 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
424 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
425 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
425 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
426 exit 1
426 exit 1
427 fi
427 fi
428
428
429 # Check if specified FBTURBOSRC_DIR directory exists
429 # Check if specified FBTURBOSRC_DIR directory exists
430 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
430 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
431 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
431 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
432 exit 1
432 exit 1
433 fi
433 fi
434
434
435 # Check if specified CHROOT_SCRIPTS directory exists
435 # Check if specified CHROOT_SCRIPTS directory exists
436 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
436 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
437 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
437 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
438 exit 1
438 exit 1
439 fi
439 fi
440
440
441 # Check if specified device mapping already exists (will be used by cryptsetup)
441 # Check if specified device mapping already exists (will be used by cryptsetup)
442 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
442 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
443 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
443 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
444 exit 1
444 exit 1
445 fi
445 fi
446
446
447 # Don't clobber an old build
447 # Don't clobber an old build
448 if [ -e "$BUILDDIR" ] ; then
448 if [ -e "$BUILDDIR" ] ; then
449 echo "error: directory ${BUILDDIR} already exists, not proceeding"
449 echo "error: directory ${BUILDDIR} already exists, not proceeding"
450 exit 1
450 exit 1
451 fi
451 fi
452
452
453 # Setup chroot directory
453 # Setup chroot directory
454 mkdir -p "${R}"
454 mkdir -p "${R}"
455
455
456 # Check if build directory has enough of free disk space >512MB
456 # Check if build directory has enough of free disk space >512MB
457 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
457 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
458 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
458 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
459 exit 1
459 exit 1
460 fi
460 fi
461
461
462 set -x
462 set -x
463
463
464 # Call "cleanup" function on various signals and errors
464 # Call "cleanup" function on various signals and errors
465 trap cleanup 0 1 2 3 6
465 trap cleanup 0 1 2 3 6
466
466
467 # Add required packages for the minbase installation
467 # Add required packages for the minbase installation
468 if [ "$ENABLE_MINBASE" = true ] ; then
468 if [ "$ENABLE_MINBASE" = true ] ; then
469 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
469 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
470 fi
470 fi
471
471
472 # Add required locales packages
472 # Add required locales packages
473 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || ([ -n XKB_MODEL ] || [ -n XKB_LAYOUT ] || [ -n XKB_VARIANT ] || [ -n XKB_OPTIONS ]); then
473 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || ([ -n XKB_MODEL ] || [ -n XKB_LAYOUT ] || [ -n XKB_VARIANT ] || [ -n XKB_OPTIONS ]); then
474 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
474 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
475 fi
475 fi
476
476
477 # Add parted package, required to get partprobe utility
477 # Add parted package, required to get partprobe utility
478 if [ "$EXPANDROOT" = true ] ; then
478 if [ "$EXPANDROOT" = true ] ; then
479 APT_INCLUDES="${APT_INCLUDES},parted"
479 APT_INCLUDES="${APT_INCLUDES},parted"
480 fi
480 fi
481
481
482 # Add dbus package, recommended if using systemd
482 # Add dbus package, recommended if using systemd
483 if [ "$ENABLE_DBUS" = true ] ; then
483 if [ "$ENABLE_DBUS" = true ] ; then
484 APT_INCLUDES="${APT_INCLUDES},dbus"
484 APT_INCLUDES="${APT_INCLUDES},dbus"
485 fi
485 fi
486
486
487 # Add iptables IPv4/IPv6 package
487 # Add iptables IPv4/IPv6 package
488 if [ "$ENABLE_IPTABLES" = true ] ; then
488 if [ "$ENABLE_IPTABLES" = true ] ; then
489 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
489 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
490 fi
490 fi
491
491
492 # Add openssh server package
492 # Add openssh server package
493 if [ "$ENABLE_SSHD" = true ] ; then
493 if [ "$ENABLE_SSHD" = true ] ; then
494 APT_INCLUDES="${APT_INCLUDES},openssh-server"
494 APT_INCLUDES="${APT_INCLUDES},openssh-server"
495 fi
495 fi
496
496
497 # Add alsa-utils package
497 # Add alsa-utils package
498 if [ "$ENABLE_SOUND" = true ] ; then
498 if [ "$ENABLE_SOUND" = true ] ; then
499 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
499 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
500 fi
500 fi
501
501
502 # Add rng-tools package
502 # Add rng-tools package
503 if [ "$ENABLE_HWRANDOM" = true ] ; then
503 if [ "$ENABLE_HWRANDOM" = true ] ; then
504 APT_INCLUDES="${APT_INCLUDES},rng-tools"
504 APT_INCLUDES="${APT_INCLUDES},rng-tools"
505 fi
505 fi
506
506
507 # Add fbturbo video driver
507 # Add fbturbo video driver
508 if [ "$ENABLE_FBTURBO" = true ] ; then
508 if [ "$ENABLE_FBTURBO" = true ] ; then
509 # Enable xorg package dependencies
509 # Enable xorg package dependencies
510 ENABLE_XORG=true
510 ENABLE_XORG=true
511 fi
511 fi
512
512
513 # Add user defined window manager package
513 # Add user defined window manager package
514 if [ -n "$ENABLE_WM" ] ; then
514 if [ -n "$ENABLE_WM" ] ; then
515 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
515 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
516
516
517 # Enable xorg package dependencies
517 # Enable xorg package dependencies
518 ENABLE_XORG=true
518 ENABLE_XORG=true
519 fi
519 fi
520
520
521 # Add xorg package
521 # Add xorg package
522 if [ "$ENABLE_XORG" = true ] ; then
522 if [ "$ENABLE_XORG" = true ] ; then
523 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
523 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
524 fi
524 fi
525
525
526 # Replace selected packages with smaller clones
526 # Replace selected packages with smaller clones
527 if [ "$ENABLE_REDUCE" = true ] ; then
527 if [ "$ENABLE_REDUCE" = true ] ; then
528 # Add levee package instead of vim-tiny
528 # Add levee package instead of vim-tiny
529 if [ "$REDUCE_VIM" = true ] ; then
529 if [ "$REDUCE_VIM" = true ] ; then
530 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
530 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
531 fi
531 fi
532
532
533 # Add dropbear package instead of openssh-server
533 # Add dropbear package instead of openssh-server
534 if [ "$REDUCE_SSHD" = true ] ; then
534 if [ "$REDUCE_SSHD" = true ] ; then
535 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
535 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
536 fi
536 fi
537 fi
537 fi
538
538
539 if [ "$RELEASE" != "jessie" ] ; then
539 if [ "$RELEASE" != "jessie" ] ; then
540 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
540 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
541 fi
541 fi
542
542
543 # Configure kernel sources if no KERNELSRC_DIR
543 # Configure kernel sources if no KERNELSRC_DIR
544 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
544 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
545 KERNELSRC_CONFIG=true
545 KERNELSRC_CONFIG=true
546 fi
546 fi
547
547
548 # Configure reduced kernel
548 # Configure reduced kernel
549 if [ "$KERNEL_REDUCE" = true ] ; then
549 if [ "$KERNEL_REDUCE" = true ] ; then
550 KERNELSRC_CONFIG=false
550 KERNELSRC_CONFIG=false
551 fi
551 fi
552
552
553 # Configure qemu compatible kernel
553 # Configure qemu compatible kernel
554 if [ "$ENABLE_QEMU" = true ] ; then
554 if [ "$ENABLE_QEMU" = true ] ; then
555 DTB_FILE=vexpress-v2p-ca15_a7.dtb
555 DTB_FILE=vexpress-v2p-ca15_a7.dtb
556 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
556 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
557 KERNEL_DEFCONFIG="vexpress_defconfig"
557 KERNEL_DEFCONFIG="vexpress_defconfig"
558 if [ "$KERNEL_MENUCONFIG" = false ] ; then
558 if [ "$KERNEL_MENUCONFIG" = false ] ; then
559 KERNEL_OLDDEFCONFIG=true
559 KERNEL_OLDDEFCONFIG=true
560 fi
560 fi
561 fi
561 fi
562
562
563 # Execute bootstrap scripts
563 # Execute bootstrap scripts
564 for SCRIPT in bootstrap.d/*.sh; do
564 for SCRIPT in bootstrap.d/*.sh; do
565 head -n 3 "$SCRIPT"
565 head -n 3 "$SCRIPT"
566 . "$SCRIPT"
566 . "$SCRIPT"
567 done
567 done
568
568
569 ## Execute custom bootstrap scripts
569 ## Execute custom bootstrap scripts
570 if [ -d "custom.d" ] ; then
570 if [ -d "custom.d" ] ; then
571 for SCRIPT in custom.d/*.sh; do
571 for SCRIPT in custom.d/*.sh; do
572 . "$SCRIPT"
572 . "$SCRIPT"
573 done
573 done
574 fi
574 fi
575
575
576 # Execute custom scripts inside the chroot
576 # Execute custom scripts inside the chroot
577 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
577 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
578 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
578 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
579 chroot_exec /bin/bash -x <<'EOF'
579 chroot_exec /bin/bash -x <<'EOF'
580 for SCRIPT in /chroot_scripts/* ; do
580 for SCRIPT in /chroot_scripts/* ; do
581 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
581 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
582 $SCRIPT
582 $SCRIPT
583 fi
583 fi
584 done
584 done
585 EOF
585 EOF
586 rm -rf "${R}/chroot_scripts"
586 rm -rf "${R}/chroot_scripts"
587 fi
587 fi
588
588
589 # Remove c/c++ build environment from the chroot
589 # Remove c/c++ build environment from the chroot
590 chroot_remove_cc
590 chroot_remove_cc
591
591
592 # Remove apt-utils
592 # Remove apt-utils
593 if [ "$RELEASE" = "jessie" ] ; then
593 if [ "$RELEASE" = "jessie" ] ; then
594 chroot_exec apt-get purge -qq -y --force-yes apt-utils
594 chroot_exec apt-get purge -qq -y --force-yes apt-utils
595 fi
595 fi
596
596
597 # Generate required machine-id
597 # Generate required machine-id
598 MACHINE_ID=$(dbus-uuidgen)
598 MACHINE_ID=$(dbus-uuidgen)
599 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
599 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
600 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
600 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
601
601
602 # APT Cleanup
602 # APT Cleanup
603 chroot_exec apt-get -y clean
603 chroot_exec apt-get -y clean
604 chroot_exec apt-get -y autoclean
604 chroot_exec apt-get -y autoclean
605 chroot_exec apt-get -y autoremove
605 chroot_exec apt-get -y autoremove
606
606
607 # Unmount mounted filesystems
607 # Unmount mounted filesystems
608 umount -l "${R}/proc"
608 umount -l "${R}/proc"
609 umount -l "${R}/sys"
609 umount -l "${R}/sys"
610
610
611 # Clean up directories
611 # Clean up directories
612 rm -rf "${R}/run/*"
612 rm -rf "${R}/run/*"
613 rm -rf "${R}/tmp/*"
613 rm -rf "${R}/tmp/*"
614
614
615 # Clean up files
615 # Clean up files
616 rm -f "${ETC_DIR}/ssh/ssh_host_*"
616 rm -f "${ETC_DIR}/ssh/ssh_host_*"
617 rm -f "${ETC_DIR}/dropbear/dropbear_*"
617 rm -f "${ETC_DIR}/dropbear/dropbear_*"
618 rm -f "${ETC_DIR}/apt/sources.list.save"
618 rm -f "${ETC_DIR}/apt/sources.list.save"
619 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
619 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
620 rm -f "${ETC_DIR}/*-"
620 rm -f "${ETC_DIR}/*-"
621 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
621 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
622 rm -f "${ETC_DIR}/resolv.conf"
622 rm -f "${ETC_DIR}/resolv.conf"
623 rm -f "${R}/root/.bash_history"
623 rm -f "${R}/root/.bash_history"
624 rm -f "${R}/var/lib/urandom/random-seed"
624 rm -f "${R}/var/lib/urandom/random-seed"
625 rm -f "${R}/initrd.img"
625 rm -f "${R}/initrd.img"
626 rm -f "${R}/vmlinuz"
626 rm -f "${R}/vmlinuz"
627 rm -f "${R}${QEMU_BINARY}"
627 rm -f "${R}${QEMU_BINARY}"
628
628
629 if [ "$ENABLE_QEMU" = true ] ; then
629 if [ "$ENABLE_QEMU" = true ] ; then
630 # Setup QEMU directory
630 # Setup QEMU directory
631 mkdir "${BASEDIR}/qemu"
631 mkdir "${BASEDIR}/qemu"
632
632
633 # Copy kernel image to QEMU directory
633 # Copy kernel image to QEMU directory
634 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
634 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
635
635
636 # Copy kernel config to QEMU directory
636 # Copy kernel config to QEMU directory
637 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
637 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
638
638
639 # Copy kernel dtbs to QEMU directory
639 # Copy kernel dtbs to QEMU directory
640 for dtb in "${BOOT_DIR}/"*.dtb ; do
640 for dtb in "${BOOT_DIR}/"*.dtb ; do
641 if [ -f "${dtb}" ] ; then
641 if [ -f "${dtb}" ] ; then
642 install_readonly "${dtb}" "${BASEDIR}/qemu/"
642 install_readonly "${dtb}" "${BASEDIR}/qemu/"
643 fi
643 fi
644 done
644 done
645
645
646 # Copy kernel overlays to QEMU directory
646 # Copy kernel overlays to QEMU directory
647 if [ -d "${BOOT_DIR}/overlays" ] ; then
647 if [ -d "${BOOT_DIR}/overlays" ] ; then
648 # Setup overlays dtbs directory
648 # Setup overlays dtbs directory
649 mkdir "${BASEDIR}/qemu/overlays"
649 mkdir "${BASEDIR}/qemu/overlays"
650
650
651 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
651 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
652 if [ -f "${dtb}" ] ; then
652 if [ -f "${dtb}" ] ; then
653 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
653 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
654 fi
654 fi
655 done
655 done
656 fi
656 fi
657
657
658 # Copy u-boot files to QEMU directory
658 # Copy u-boot files to QEMU directory
659 if [ "$ENABLE_UBOOT" = true ] ; then
659 if [ "$ENABLE_UBOOT" = true ] ; then
660 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
660 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
661 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
661 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
662 fi
662 fi
663 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
663 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
664 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
664 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
665 fi
665 fi
666 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
666 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
667 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
667 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
668 fi
668 fi
669 fi
669 fi
670
670
671 # Copy initramfs to QEMU directory
671 # Copy initramfs to QEMU directory
672 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
672 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
673 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
673 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
674 fi
674 fi
675 fi
675 fi
676
676
677 # Calculate size of the chroot directory in KB
677 # Calculate size of the chroot directory in KB
678 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
678 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
679
679
680 # Calculate the amount of needed 512 Byte sectors
680 # Calculate the amount of needed 512 Byte sectors
681 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
681 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
682 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
682 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
683 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
683 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
684
684
685 # The root partition is EXT4
685 # The root partition is EXT4
686 # This means more space than the actual used space of the chroot is used.
686 # This means more space than the actual used space of the chroot is used.
687 # As overhead for journaling and reserved blocks 35% are added.
687 # As overhead for journaling and reserved blocks 35% are added.
688 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
688 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
689
689
690 # Calculate required image size in 512 Byte sectors
690 # Calculate required image size in 512 Byte sectors
691 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
691 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
692
692
693 # Prepare image file
693 # Prepare image file
694 if [ "$ENABLE_SPLITFS" = true ] ; then
694 if [ "$ENABLE_SPLITFS" = true ] ; then
695 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
695 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
696 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
696 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
697 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
697 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
698 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
698 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
699
699
700 # Write firmware/boot partition tables
700 # Write firmware/boot partition tables
701 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
701 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
702 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
702 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
703 EOM
703 EOM
704
704
705 # Write root partition table
705 # Write root partition table
706 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
706 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
707 ${TABLE_SECTORS},${ROOT_SECTORS},83
707 ${TABLE_SECTORS},${ROOT_SECTORS},83
708 EOM
708 EOM
709
709
710 # Setup temporary loop devices
710 # Setup temporary loop devices
711 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME-frmw.img")"
711 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
712 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME-root.img")"
712 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
713 else # ENABLE_SPLITFS=false
713 else # ENABLE_SPLITFS=false
714 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
714 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
715 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
715 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
716
716
717 # Write partition table
717 # Write partition table
718 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
718 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
719 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
719 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
720 ${ROOT_OFFSET},${ROOT_SECTORS},83
720 ${ROOT_OFFSET},${ROOT_SECTORS},83
721 EOM
721 EOM
722
722
723 # Setup temporary loop devices
723 # Setup temporary loop devices
724 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME.img")"
724 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
725 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME.img")"
725 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
726 fi
726 fi
727
727
728 if [ "$ENABLE_CRYPTFS" = true ] ; then
728 if [ "$ENABLE_CRYPTFS" = true ] ; then
729 # Create dummy ext4 fs
729 # Create dummy ext4 fs
730 mkfs.ext4 "$ROOT_LOOP"
730 mkfs.ext4 "$ROOT_LOOP"
731
731
732 # Setup password keyfile
732 # Setup password keyfile
733 touch .password
733 touch .password
734 chmod 600 .password
734 chmod 600 .password
735 echo -n ${CRYPTFS_PASSWORD} > .password
735 echo -n ${CRYPTFS_PASSWORD} > .password
736
736
737 # Initialize encrypted partition
737 # Initialize encrypted partition
738 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
738 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
739
739
740 # Open encrypted partition and setup mapping
740 # Open encrypted partition and setup mapping
741 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
741 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
742
742
743 # Secure delete password keyfile
743 # Secure delete password keyfile
744 shred -zu .password
744 shred -zu .password
745
745
746 # Update temporary loop device
746 # Update temporary loop device
747 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
747 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
748
748
749 # Wipe encrypted partition (encryption cipher is used for randomness)
749 # Wipe encrypted partition (encryption cipher is used for randomness)
750 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
750 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
751 fi
751 fi
752
752
753 # Build filesystems
753 # Build filesystems
754 mkfs.vfat "$FRMW_LOOP"
754 mkfs.vfat "$FRMW_LOOP"
755 mkfs.ext4 "$ROOT_LOOP"
755 mkfs.ext4 "$ROOT_LOOP"
756
756
757 # Mount the temporary loop devices
757 # Mount the temporary loop devices
758 mkdir -p "$BUILDDIR/mount"
758 mkdir -p "$BUILDDIR/mount"
759 mount "$ROOT_LOOP" "$BUILDDIR/mount"
759 mount "$ROOT_LOOP" "$BUILDDIR/mount"
760
760
761 mkdir -p "$BUILDDIR/mount/boot/firmware"
761 mkdir -p "$BUILDDIR/mount/boot/firmware"
762 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
762 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
763
763
764 # Copy all files from the chroot to the loop device mount point directory
764 # Copy all files from the chroot to the loop device mount point directory
765 rsync -a "${R}/" "$BUILDDIR/mount/"
765 rsync -a "${R}/" "$BUILDDIR/mount/"
766
766
767 # Unmount all temporary loop devices and mount points
767 # Unmount all temporary loop devices and mount points
768 cleanup
768 cleanup
769
769
770 # Create block map file(s) of image(s)
770 # Create block map file(s) of image(s)
771 if [ "$ENABLE_SPLITFS" = true ] ; then
771 if [ "$ENABLE_SPLITFS" = true ] ; then
772 # Create block map files for "bmaptool"
772 # Create block map files for "bmaptool"
773 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
773 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
774 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
774 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
775
775
776 # Image was successfully created
776 # Image was successfully created
777 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
777 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
778 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
778 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
779 else
779 else
780 # Create block map file for "bmaptool"
780 # Create block map file for "bmaptool"
781 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
781 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
782
782
783 # Image was successfully created
783 # Image was successfully created
784 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
784 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
785
785
786 # Create qemu qcow2 image
786 # Create qemu qcow2 image
787 if [ "$ENABLE_QEMU" = true ] ; then
787 if [ "$ENABLE_QEMU" = true ] ; then
788 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
788 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
789 QEMU_SIZE=16G
789 QEMU_SIZE=16G
790
790
791 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
791 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
792 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
792 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
793
793
794 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
794 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
795 fi
795 fi
796 fi
796 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant